(function(){
 const Ld = sLoader;

 Ld.module('filter-emboss',function(){

  const Emboss = {};

  Emboss.blendMode = "mix-blend-mode: soft-light;";

  const dilate = 4;
  const blur = 4;

  Emboss.getViewBox = function(srcbb){
   let ex = dilate + blur;
   return{
    x:srcbb.x-ex, y:srcbb.y-ex,
    width:srcbb.width+2*ex, height:srcbb.height+2*ex,
   };
  };
  
  Emboss.makeSvgText = function(id,vb,srcbb){
// let scale = p.scale;
   let svg =
   `<filter id="${id}" filterUnits="userSpaceOnUse"
      x="${vb.x}" y="${vb.y}" width="${vb.width}" height="${vb.height}" >
    <feColorMatrix type="saturate" values="0" result="mono" />
     <feColorMatrix values="-1 0 0 0 1 0 -1 0 0 1 0 0 -1 0 1 0 0 0 1 0"/>
     <feMorphology operator="dilate" radius="${dilate}" />
     <feGaussianBlur stdDeviation="${blur}" result="back"  />
     <feComposite in="mono" in2="back"/>
     <feConvolveMatrix preserveAlpha="true" divisor="2"
      color-interpolation-filters="sRGB" bias="0.5"
      order="3" kernelMatrix="1 0 0 0 0 0 0 0 -1"
     />
    </filter>`;
   return svg;
  };

  return Emboss;
 });

})();

 
