/*
*/
(function(){
 'use strict';
 const Ld = sLoader;
 Ld.module('layerParts',function(){

  const So = Ld.use('sobject');
  const M  = Ld.ref('main');
  const Mn = Ld.use('menu');
  const U  = Ld.use('utility');

  const Lp = So.derive();
  Lp._className = 'LayerPats';

  Lp.values = {};
  Lp.menuDefs = {};
  Lp.dirty = true;
  Lp.id = '';  // 


  Lp.constructor = function(layerId,zIndex){
//   Object.assign(this,properties);
   this.id = layerId;
   this.zIndex = zIndex;
   this.values = {};
   this.menuDefs = {};
   this.defineMenu();
   this.menu = Mn.CMenuDef.create({
    id:this.id,
    items:this.menuDefs,
    owner:this,
    sig: this.sig,
   });
   this.initialize();
  };
  

  Lp.defineMenu = function(){};

// createLayer
  Lp.initialize = function(){
   let el = this.containerEl = document.createElement('div');
   U.setStyle(el.style,{
    position:'absolute', top:0, bottom:0, left:0, right:0,
    zIndex:this.zIndex,
   });
   M.paneEl.appendChild(el);
  };

  Lp.addMenu = function(menuDefs){
   Object.assign(this.menuDefs,menuDefs);
  };

// 使ってる？
  Lp.getSaveData = function(){
   return this.values;
  };

  Lp.disp = function(){
   if ( this.dirty ) {
    this.dirty = false;
    let p = {
     cRect: M.cRect
    };
// 
//    let layer = document.getElementById(this.id);
    let layer = this.containerEl;
    if ( layer ) {
     let svgText = this.makeSvgText(false,p) || '';
     layer.innerHTML = svgText;
     let svg = layer.getElementsByTagName('svg')[0];
     if ( svg ) {
      layer.style.mixBlendMode = svg.style.mixBlendMode;
     }
    }
    if ( this.highlight ) {
     this.highlight();
    }
   }
  };

  Lp.makeSvgText = function(){
   return '';
  };

// こっち側で持っているべきか...
  Lp.onresize = function(){
   this.dirty = 1;
//   let layer = document.getElementById(this.id);
/*
   let layer = this.containerEl;
   layer.style.width  = M.cRect.width+"px";
   layer.style.height = M.cRect.height+"px";
   layer.style.left   = M.cRect.x+"px";
   layer.style.top    = M.cRect.y+"px";
   this.dirty = 1;
*/
  };


  Lp.highlight = function(){
   if ( this.getHighlightBox ) {
    let box = this.getHighlightBox();
    if ( this.highlightStatus && box ) {
     let frame = this.highlightFrame;
     if ( !frame ) {
      frame = this.highlightFrame = document.createElement('div');
      U.setStyle(frame.style,{
       position:'absolute', boxSizing:'border-box', zIndex:9,
       borderStyle:'solid', borderColor:'blue', opacity:'0.4',
      });
      M.paneEl.appendChild(frame);
     }
     let scale = M.cRect.diagonal;
     U.setStyle(frame.style,{
      left: (scale*box.x + M.cRect.width/2)+'px',
      top : (scale*box.y + M.cRect.height/2)+'px',
      width: (scale*box.width)+'px',
      height: (scale*box.height)+'px',
      borderWidth:(scale*4/1000)+'px',
     });
    } else {
     if ( this.highlightFrame ) {
      M.paneEl.removeChild(this.highlightFrame);
      this.highlightFrame = undefined;
     }
    }
   }
  };


  Lp.onChange = function(values){
   this.dirty = true;
   Object.assign(this.values,values);
   M.disp();
  };

  Lp.loadSetting = 
  Lp.restoreSessionStatus = function(data){
   this.menu.restore(data);
   Object.assign(this.values,this.menu.getValues());
  };


  Lp.getSetting = 
  Lp.getSessionStatus = function(){
   return this.values;
  }

  return Lp;

 });
})();
