(function(){
 const Ld = sLoader;

 Ld.module('filter-shadow',function(){

  const Shadow = {};

  Shadow.blendMode = "";

// const AMOUNT 
//  fontSize

  const BLUR = 2;
  const OFFSET = 2;
  const ANGLE = 60;

  Shadow.getViewBox = function(srcbb){
   let fontSize = Math.min(srcbb.width,srcbb.height);
   let blur = BLUR/100*fontSize;
   let dx = OFFSET/100*fontSize;
   let ex = blur*2 + Math.abs(dx);
   return{
    x:srcbb.x-ex, y:srcbb.y-ex,
    width:srcbb.width+2*ex, height:srcbb.height+2*ex,
   };
  };

  Shadow.makeSvgText = function(id,vb,srcbb){
   let fontSize = Math.min(srcbb.width,srcbb.height);
   let blur = BLUR/100*fontSize;
   let dx = Math.cos(2*Math.PI*ANGLE/360)*OFFSET/100*fontSize;
   let dy = Math.sin(2*Math.PI*ANGLE/360)*OFFSET/100*fontSize;
   let svg = `<filter id="${id}"
     filterUnits="userSpaceOnUse"
     x="${vb.x}" y="${vb.y}" width="${vb.width}" height="${vb.height}" >`;
   svg += 
    `<feColorMatrix type="saturate" values="0" />
     <feColorMatrix values="-1 0 0 0 1 0 -1 0 0 1 0 0 -1 0 1 0 0 0 1 0"/>`;
   if ( blur > 0 ) {
    svg += `<feGaussianBlur stdDeviation="${blur}" />`;
   }
   svg += `<feOffset dx="${dx}" dy="${dy}" result="shadow" />`;
   svg +=
    `<feMerge>
      <feMergeNode in="shadow"/>
      <feMergeNode in="SourceGraphic"/>
     </feMerge>
    </filter>`;
   return svg;
  };

  return Shadow;
 });

})();

 
