(function(){
 'use strict';
 const Ld = sLoader;

 Ld.module('help',function(){

  let Help = {};
  let Mn = Ld.use('menu');
  let Mb = Ld.use('messageBox');
  let Icon = Ld.use('icon');


  Help.init = function(){
   Mn.CMenuDef.create({
    id:'help',
    items:{
     about: Mn.button({priority:90, text:'About',
      onclick:function(){ Mb.messageBox({
       title:'About', text: aboutText()
      }); },
     }),
     credit: Mn.button({priority:10, text:'Credit',
      onclick:function(){ Mb.messageBox({
       title:'Credit', text: creditText() });
      },
     }),
    },
   });
  };


//
  let HTML_ROOT = 'https://www2.tamagaro.net/tool/scabar';

  function aboutText(){
   let HTML_ROOT_WBR = HTML_ROOT.replace(/\/([^\/])/g, '\/<wbr>$1');
console.log(HTML_ROOT_WBR);
return `<div class="help">
<h2>Scabar</h2>
 <p>Version ${Ld.appVersion}</p>
 <p>build __BUILD_DATE__</p>
 <p><b>Scabar</b> is a image processing software
   with scale bar, cropping, watermark function.
   For images taken with an Olympus camera,
    the scale bar can be generated automatically
   (currently supported for TG-5 only).</p>
 <p><b>Scabar</b> is free software.
  Anyone can use this program WITHOUT ANY WARRANTY.
 </p>
 <p><b>Scabar</b> is a Javascript application
  that runs on a web browser on a PC or mobile device.
 </p>
 <p>For more detail, see
  <a href="${HTML_ROOT}/">${HTML_ROOT_WBR}/</a>.
 </p>
</div>`;
  };


  function creditText(){
return `<div class="help">
 <table class="padding" style="">
 <colgroup>
  <col style="width:30%;" />
  <col style="width:70%;" />
 </colgroup>
 <tbody>
 <tr>
  <td class="right">Main Program</td>
  <td>©A. Koguchi<br>
   <a href="mailto:info@tamagaro.net">info@tamagaro.net</a>
  </td>
 </tr>
 <tr>
  <td class="right">Google Icon</td>
  <td>©Google<br>
   <a href="https://material.io/icons/">https://material.io/icons/</a></td>
 </tr>
 <tr>
  <td class="right">Font Detector</td>
  <td>©Lalit Patel<br>
   <a href="https://gist.github.com/szepeviktor/d28dfcfc889fe61763f3">
    https://gist.github.com/<wbr>szepeviktor/<wbr>d28dfcfc889fe61763f3</a></td>
  </td>
 </tr>
 </tbody></table>
</div>`;
  };


  return Help;
 });
})();
